Mail::Box::Locker::Flock(3)

NAME
Mail::Box::Locker::Flock - lock a folder using kernel file-locking

INHERITANCE
 Mail::Box::Locker::Flock
   is a Mail::Box::Locker
   is a Mail::Reporter

SYNOPSIS
 See Mail::Box::Locker

DESCRIPTION
The "::Flock" object locks the folder by creating an exclusive lock on the file using the kernel's "flock" facilities. This lock is created on a separate file-handle to the folder file, so not the handle which is reading.

File locking does not work in some situations, for instance for operating systems do not support "flock".

Extends "DESCRIPTION" in Mail::Box::Locker.

METHODS
Extends "METHODS" in Mail::Box::Locker.

  Constructors
Extends "Constructors" in Mail::Box::Locker.

Mail::Box::Locker::Flock->new(%options)
     -Option --Defined in       --Default
      expires  Mail::Box::Locker  1 hour
      file     Mail::Box::Locker  undef
      folder   Mail::Box::Locker  <undef>
      log      Mail::Reporter     'WARNINGS'
      method   Mail::Box::Locker  'FLOCK'
      timeout  Mail::Box::Locker  10
      trace    Mail::Reporter     'WARNINGS'

    expires => SECONDS
    file => FILENAME
    folder => FOLDER
    log => LEVEL
    method => STRING|CLASS|ARRAY
    timeout => SECONDS|'NOTIMEOUT'
    trace => LEVEL

  Attributes
Extends "Attributes" in Mail::Box::Locker.

$obj->expires( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

$obj->timeout( [SECONDS] )
    Inherited, see "Attributes" in Mail::Box::Locker

  The Locker
Extends "The Locker" in Mail::Box::Locker.

$obj->filename( [$filename] )
    Inherited, see "The Locker" in Mail::Box::Locker

$obj->folder( [$folder] )
    Inherited, see "The Locker" in Mail::Box::Locker

$obj->name()
    Inherited, see "The Locker" in Mail::Box::Locker

  Locking
Extends "Locking" in Mail::Box::Locker.

$obj->hasLock()
    Inherited, see "Locking" in Mail::Box::Locker

$obj->isLocked()
$obj->lock()
$obj->unlock()
    Inherited, see "Locking" in Mail::Box::Locker

  Error handling
Extends "Error handling" in Mail::Box::Locker.

$obj->AUTOLOAD()
    Inherited, see "Error handling" in Mail::Reporter

$obj->addReport($object)
    Inherited, see "Error handling" in Mail::Reporter

$obj->defaultTrace( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )
Mail::Box::Locker::Flock->defaultTrace( [$level]|[$loglevel, $tracelevel]|[$level, $callback] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->errors()
    Inherited, see "Error handling" in Mail::Reporter

$obj->log( [$level, [$strings]] )
Mail::Box::Locker::Flock->log( [$level, [$strings]] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->logPriority($level)
Mail::Box::Locker::Flock->logPriority($level)
    Inherited, see "Error handling" in Mail::Reporter

$obj->logSettings()
    Inherited, see "Error handling" in Mail::Reporter

$obj->notImplemented()
    Inherited, see "Error handling" in Mail::Reporter

$obj->report( [$level] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->reportAll( [$level] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->trace( [$level] )
    Inherited, see "Error handling" in Mail::Reporter

$obj->warnings()
    Inherited, see "Error handling" in Mail::Reporter

  Cleanup
Extends "Cleanup" in Mail::Box::Locker.

$obj->DESTROY()
    Inherited, see "Cleanup" in Mail::Box::Locker

DIAGNOSTICS

Warning: Folder $folder already flocked
    The folder is already locked, but you attempt to lock it again. The behavior of double flock's is platform dependent, and therefore should not be attempted. The second lock is ignored (but the unlock isn't)

Error: Package $package does not implement $method.
    Fatal error: the specific package (or one of its superclasses) does not implement this method where it should. This message means that some other related classes do implement this method however the class at hand does not. Probably you should investigate this and probably inform the author of the package.

Error: Unable to check lock file $filename for $folder: $!
    To check whether the filename is used to flock a folder, the file must be opened. Apparently this fails, which does not mean that the folder is locked neither that it is unlocked.

Error: Unable to open flock file $filename for $folder: $!
    For flock-ing a folder it must be opened, which does not succeed for the specified reason.

Error: Will never get a flock at $filename for $folder: $!
    Tried to flock the folder, but it did not succeed. The error code received from the OS indicates that it will not succeed ever, so we do not need to try again.

SEE ALSO
This module is part of Mail-Box distribution version 3.009, built on August 18, 2020. Website: http://perl.overmeer.net/CPAN/

LICENSE
Copyrights 2001-2020 by [Mark Overmeer]. For other contributors see ChangeLog.

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself. See http://dev.perl.org/licenses/